From 286d2b1bada7c74c8627ac468e94bcb3f99d43b6 Mon Sep 17 00:00:00 2001
From: Jorge Chamorro Bieling <jorge@jorgechamorro.com>
Date: Sat, 6 Nov 2010 14:13:48 +0100
Subject: [PATCH] fs dangling buffer bug hack

---
 lib/fs.js |    5 ++++-
 1 files changed, 4 insertions(+), 1 deletions(-)

diff --git a/lib/fs.js b/lib/fs.js
index ecbe013..7d7e08a 100644
--- a/lib/fs.js
+++ b/lib/fs.js
@@ -216,6 +216,9 @@ fs.readSync = function (fd, buffer, offset, length, position) {
 };
 
 fs.write = function (fd, buffer, offset, length, position, callback) {
+  function wrapCB (err, written) {
+    if (callback) callback(err, written);
+  }
   if (!Buffer.isBuffer(buffer)) {
     // legacy string interface (fd, data, position, encoding, callback)
     callback = arguments[4];
@@ -235,7 +238,7 @@ fs.write = function (fd, buffer, offset, length, position, callback) {
     return;
   }
 
-  binding.write(fd, buffer, offset, length, position, callback || noop);
+  binding.write(fd, buffer, offset, length, position, wrapCB);
 };
 
 fs.writeSync = function (fd, buffer, offset, length, position) {
-- 
1.7.1

